//
//  UIScrollView+QURefresh.h
//  QURefresh_Example
//
//  Created by 瞿伦平 on 2018/6/5.
//  Copyright © 2018年 qulunping@gmail.com. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <MJRefresh/MJRefresh.h>
#import <DZNEmptyDataSet/UIScrollView+EmptyDataSet.h>

#define TABLE_PAGE_ROW  20  //默认每次页面调用20条数据

typedef void (^TableLoadNormalDataBlock)(void);
typedef void (^TableLoadErrorDataBlock)(BOOL isNoData, NSString *errorStr);
typedef void (^QURefreshingBlock)(BOOL isHeaderRereshing, int page, int pageRow);


@interface UIScrollView (QURefresh)<DZNEmptyDataSetSource, DZNEmptyDataSetDelegate>
@property(nonatomic,assign) int                                 page;  //!< 当前页码数
@property(nonatomic,assign) int                                 pageRow;  //!< 每页数量 默认20条数据
@property(nonatomic,assign) int                                 pageFirst;  //!< 下拉时取的页码数 默认0
@property(nonatomic,assign) BOOL                                tableIsReloading; //!< 是否正在加载
@property(nonatomic,assign) BOOL                                tableHaveLoaded; //!< 是否已经被加载刷新过, fase为默认未加载时
@property(nonatomic,  copy) QURefreshingBlock                   qu_refreshingBlock;  //!<  正在刷新的回调

@property(nonatomic,strong) NSString*                           errMsg;  //!< 错误信息显示
@property(nonatomic,strong) NSString*                           emptyDataMsg;  //!< 暂无数据信息显示
@property(nonatomic,strong) UIImage*                            errImg;  //!< 错误信息显示图片

@property (nonatomic, assign, readonly, getter = isHeaderRefreshing) BOOL headerRefreshing;  //!< 是否正在下拉刷新
@property (nonatomic, assign, readonly, getter = isFooterRefreshing) BOOL footerRefreshing;  //!< 是否正在上拉刷新


/** 设置表格有头部刷新 */
-(void)qu_setHaveHeader;

/** 设置表格有底部刷新 */
-(void)qu_setHaveFooter;

/** 设置表格有头部底部刷新 */
-(void)qu_setHaveHeaderFooter;

/** 表格开始头部刷新 */
-(void)qu_headerBeginRefreshing;

/** 表格停止刷新 */
-(void)qu_endRefreshing;

/** 表格开始刷新是的回调方法 */
-(void)startRefreshingHandler:(QURefreshingBlock)refreshingBlock;


-(void)qu_loadHeaderRefreshing;
-(void)qu_loadFooterRefreshing;

/** 表格完成刷新处理 */
- (void)qu_endRefreshStatusWithAddArr:(NSArray *)arr apiStatus:(BOOL)isSuccess errorMsg:(NSString *)errorMsg;

//设置当前表格自己处理空视图
-(void)setEmptyViewInSelf;

@end



@interface UITableView (QURefresh)

@end


@interface UICollectionView (QURefresh)

@end
