//
//  UIScrollView+QURefresh.m
//  QURefresh_Example
//
//  Created by 瞿伦平 on 2018/6/5.
//  Copyright © 2018年 qulunping@gmail.com. All rights reserved.
//

#import "UIScrollView+QURefresh.h"

@implementation UIScrollView (QURefresh)

#pragma mark - get&set
NSString const *QUTableViewPageKey = @"QUTableViewPageKey";
NSString const *QUTableViewPageRowKey = @"QUTableViewPageRowKey";
NSString const *QUTableViewPageFirstKey = @"QUTableViewPageFirstKey";
NSString const *QUTableViewIsReloadingKey = @"QUTableViewIsReloadingKey";
NSString const *QUTableViewHaveLoadedKey = @"QUTableViewHaveLoadedKey";
NSString const *QUTableViewRefreshingBlockfKey = @"QUTableViewRefreshingBlockfKey";
NSString const *QUTableViewErrorMessageKey = @"QUTableViewErrorMessageKey";
NSString const *QUTableViewNoDataMessageKey = @"QUTableViewNoDataMessageKey";
NSString const *QUTableViewErrorImgKey = @"QUTableViewErrorImgKey";

@dynamic page;
@dynamic pageRow;
@dynamic pageFirst;
@dynamic tableIsReloading;
@dynamic tableHaveLoaded;
@dynamic qu_refreshingBlock;
@dynamic errMsg;
@dynamic emptyDataMsg;
@dynamic errImg;

-(int)page {
    NSNumber *number = objc_getAssociatedObject(self, &QUTableViewPageKey);
    return number.intValue;
}
-(void)setPage:(int)page
{
    NSNumber *number = [NSNumber numberWithInt:page];
    objc_setAssociatedObject(self, &QUTableViewPageKey, number, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

-(int)pageRow {
    NSNumber *number = objc_getAssociatedObject(self, &QUTableViewPageRowKey);
    return number.intValue;
}
-(void)setPageRow:(int)pageRow
{
    NSNumber *number = [NSNumber numberWithInt:pageRow];
    objc_setAssociatedObject(self, &QUTableViewPageRowKey, number, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

-(int)pageFirst {
    NSNumber *number = objc_getAssociatedObject(self, &QUTableViewPageFirstKey);
    return number.intValue;
}
-(void)setPageFirst:(int)pageFirst
{
    NSNumber *number = [NSNumber numberWithInt:pageFirst];
    objc_setAssociatedObject(self, &QUTableViewPageFirstKey, number, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

-(BOOL)tableIsReloading {
    NSNumber *number = objc_getAssociatedObject(self, &QUTableViewIsReloadingKey);
    return number.boolValue;
}
-(void)setTableIsReloading:(BOOL)tableIsReloading
{
    NSNumber *number = [NSNumber numberWithBool:tableIsReloading];
    objc_setAssociatedObject(self, &QUTableViewIsReloadingKey, number, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

-(BOOL)tableHaveLoaded {
    NSNumber *number = objc_getAssociatedObject(self, &QUTableViewHaveLoadedKey);
    return number.boolValue;
}
-(void)setTableHaveLoaded:(BOOL)tableHaveLoaded
{
    NSNumber *number = [NSNumber numberWithBool:tableHaveLoaded];
    objc_setAssociatedObject(self, &QUTableViewHaveLoadedKey, number, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}

- (void)setQu_refreshingBlock:(QURefreshingBlock)qu_refreshingBlock
{
    objc_setAssociatedObject(self, &QUTableViewRefreshingBlockfKey, qu_refreshingBlock, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}
- (QURefreshingBlock)qu_refreshingBlock
{
    return objc_getAssociatedObject(self, &QUTableViewRefreshingBlockfKey);
}

-(void)setErrMsg:(NSString *)errMsg
{
    objc_setAssociatedObject(self, &QUTableViewErrorMessageKey, errMsg, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}
-(NSString *)errMsg
{
    return objc_getAssociatedObject(self, &QUTableViewErrorMessageKey);
}

-(void)setEmptyDataMsg:(NSString *)emptyDataMsg
{
    objc_setAssociatedObject(self, &QUTableViewNoDataMessageKey, emptyDataMsg, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}
-(NSString *)emptyDataMsg
{
    return objc_getAssociatedObject(self, &QUTableViewNoDataMessageKey);
}

-(void)setErrImg:(UIImage *)errImg
{
    objc_setAssociatedObject(self, &QUTableViewErrorImgKey, errImg, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}
-(UIImage *)errImg
{
    return objc_getAssociatedObject(self, &QUTableViewErrorImgKey);
}


- (void)qu_tableInit
{
    if (self.pageRow == 0) {
        self.pageRow = TABLE_PAGE_ROW;
    }
}


#pragma mark - 设置刷新控件

-(void)qu_setHaveHeader
{
    [self qu_tableInit];
    __weak typeof(self) weakSelf = self;
    MJRefreshNormalHeader *header = [MJRefreshNormalHeader headerWithRefreshingBlock:^{
        [weakSelf qu_loadHeaderRefreshing];
    }];
    self.mj_header = header;
}

-(void)qu_setHaveFooter
{
    [self qu_tableInit];
    __weak typeof(self) weakSelf = self;
    MJRefreshAutoNormalFooter *footer = [MJRefreshAutoNormalFooter footerWithRefreshingBlock:^{
        [weakSelf qu_loadFooterRefreshing];
    }];
    footer.automaticallyRefresh = NO;  // 自动加载
    footer.refreshingTitleHidden = YES;
    footer.automaticallyHidden = NO;
    self.mj_footer = footer;
    
    self.mj_footer.hidden = YES;
}

-(void)qu_setHaveHeaderFooter
{
    [self qu_setHaveHeader];
    [self qu_setHaveFooter];
}


-(void)qu_headerBeginRefreshing
{
    self.page = self.pageFirst;
    if (self.mj_header != nil)
        [self.mj_header beginRefreshing];
}

-(void)qu_loadHeaderRefreshing
{
    self.page = self.pageFirst;
    self.tableIsReloading = YES;
    if (self.mj_footer != nil)
        self.mj_footer.hidden = YES;
    
    if (self.qu_refreshingBlock)
        self.qu_refreshingBlock(YES, self.page, self.pageRow);
}

-(void)qu_loadFooterRefreshing
{
    self.tableIsReloading = YES;
    int nextPage = self.page + 1;
    if (self.qu_refreshingBlock)
        self.qu_refreshingBlock(NO, nextPage, self.pageRow);
}

-(void)qu_endRefreshing
{
    if (self.mj_header != nil)
        [self.mj_header endRefreshing];
    
    if (self.mj_footer != nil)
        [self.mj_footer endRefreshing];
}

-(void)startRefreshingHandler:(QURefreshingBlock)refreshingBlock
{
    self.qu_refreshingBlock = refreshingBlock;
}

- (BOOL)isHeaderRefreshing
{
    if (self.mj_header != nil)
        return self.mj_header.state == MJRefreshStateRefreshing;
    else
        return NO;
}

- (BOOL)isFooterRefreshing
{
    if (self.mj_footer != nil)
        return self.mj_footer.state == MJRefreshStateRefreshing;
    else
        return NO;
}


#pragma mark - 空数据相关

-(void)setEmptyViewInSelf
{
    self.emptyDataSetSource = self;
    self.emptyDataSetDelegate = self;
}

- (BOOL)emptyDataSetShouldDisplay:(UIScrollView *)scrollView
{
    BOOL shouldShow = (self.tableHaveLoaded==NO || self.tableIsReloading==YES) ? NO : YES;
    return shouldShow;
}

- (BOOL)emptyDataSetShouldAllowTouch:(UIScrollView *)scrollView
{
    return NO;
}

- (BOOL)emptyDataSetShouldAllowScroll:(UIScrollView *)scrollView
{
    return YES;
}

- (UIImage *)imageForEmptyDataSet:(UIScrollView *)scrollView
{
    return self.errImg;
}

- (UIColor *)backgroundColorForEmptyDataSet:(UIScrollView *)scrollView
{
    return [UIColor whiteColor];
}

- (void)emptyDataSetWillAppear:(UIScrollView *)scrollView {
    [UIView animateWithDuration:0.5 animations:^{
        scrollView.contentOffset = CGPointZero;
    }];
}

- (NSAttributedString *)titleForEmptyDataSet:(UIScrollView *)scrollView
{
    NSString *text = nil;
    UIFont *font = nil;
    UIColor *textColor = nil;
    
    NSMutableDictionary *attributes = [NSMutableDictionary new];
    
    
    text = self.errMsg;
    font = [UIFont boldSystemFontOfSize:16.0];
    textColor = [UIColor blackColor];
    
    if (!text) {
        return nil;
    }
    
    if (font) [attributes setObject:font forKey:NSFontAttributeName];
    if (textColor) [attributes setObject:textColor forKey:NSForegroundColorAttributeName];
    
    return [[NSAttributedString alloc] initWithString:text attributes:attributes];
}


#pragma mark - 关于处理数据相关
- (void)qu_endRefreshStatusWithAddArr:(NSArray *)arr apiStatus:(BOOL)isSuccess errorMsg:(NSString *)errorMsg
{
    self.tableHaveLoaded = YES;
    
    if (self.headerRefreshing) {
        //下拉刷新
        if (arr.count > 0) {
            
            if (arr.count == self.pageRow) {
                if (self.mj_footer != nil)
                    [self.mj_footer endRefreshing];
            } else {
                if (self.mj_footer != nil)
                    [self.mj_footer endRefreshingWithNoMoreData];
            }
            
            if (self.mj_footer != nil)
                self.mj_footer.hidden = NO;
            
        } else {
            if (isSuccess)
                self.errMsg = self.emptyDataMsg.length>0 ? self.emptyDataMsg : @"暂无数据";
            else
                self.errMsg = errorMsg.length>0 ? errorMsg : @"网络错误";
            
            if (self.mj_footer != nil) {
                [self.mj_footer endRefreshingWithNoMoreData];
                self.mj_footer.hidden = YES;
            }
        }
        
        self.tableIsReloading = NO;
        
        if (self.mj_header != nil)
            [self.mj_header endRefreshing];
        
        [self reloadEmptyDataSet];
    } else {
        //上拉刷新
        if (isSuccess) {
            self.page = self.page + 1;
        }
        
        self.tableIsReloading = NO;
        
        if (self.mj_footer != nil) {
            self.mj_footer.hidden = NO;
            if (isSuccess && arr.count==self.pageRow)
                [self.mj_footer endRefreshing];
            else
                [self.mj_footer endRefreshingWithNoMoreData];
        }
        
    }
}


@end








@implementation UITableView (QURefresh)
- (void)qu_endRefreshStatusWithAddArr:(NSArray *)arr apiStatus:(BOOL)isSuccess errorMsg:(NSString *)errorMsg
{
    [super qu_endRefreshStatusWithAddArr:arr apiStatus:isSuccess errorMsg:errorMsg];
    [self reloadData];
}
@end




@implementation UICollectionView (QURefresh)
- (void)qu_endRefreshStatusWithAddArr:(NSArray *)arr apiStatus:(BOOL)isSuccess errorMsg:(NSString *)errorMsg
{
    [super qu_endRefreshStatusWithAddArr:arr apiStatus:isSuccess errorMsg:errorMsg];
    [self reloadData];
}
@end
